#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtCore/QSignalMapper>
#include <QModelIndex>
#include "registerdialog.h"
#include "sqlform.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void loadConnection(QString connectionName, QString serverType, QString serverName, int serverPort, QString databaseName, QString username, QString password);
    bool setupConnection(QString connectionName, QString serverType, QString serverName, int serverPort, QString databaseName, QString username, QString password);

protected:
    void changeEvent(QEvent *e);

private:
    void updateTabCloseButtons();
    Ui::MainWindow *ui;
    QSignalMapper *m_WindowMapper;
    RegisterDialog *m_RegisterDialog;
    SqlForm *m_QueryForm;

private slots:
    void setActiveSubWindow(QWidget *window);
    void closeTab(int i);
    void on_DatabaseRunQueryAction_triggered();
    void on_DatabaseEditAction_triggered();
    void on_TabLocationWestAction_triggered();
    void on_TabLocationEastAction_triggered();
    void on_TabLocationSouthAction_triggered();
    void on_TabLocationNorthAction_triggered();
    void on_ModeTabbedAction_triggered();
    void on_ModeSubWindowsAction_triggered();
    void on_HelpAboutAction_triggered();
    void on_HelpAboutQtAction_triggered();
    void on_DatabaseDeregisterAction_triggered();
    void on_DatabaseTreeWidget_doubleClicked(QModelIndex index);
    void on_DatabaseRegisterAction_triggered();
    void on_WindowMenu_aboutToShow();
};

#endif // MAINWINDOW_H
