#include "registerdialog.h"
#include "ui_registerdialog.h"

RegisterDialog::RegisterDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::RegisterDialog)
{
    ui->setupUi(this);
    QValidator *validator = new QIntValidator(0, 999999, this);
    ui->PortLineEdit->setValidator(validator);
}

RegisterDialog::~RegisterDialog()
{
    delete ui;
}

void RegisterDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

QString RegisterDialog::connectionName()
{
    return ui->ConnectionLineEdit->text();
}

void RegisterDialog::setConnectionName(const QString connectionName)
{
    ui->ConnectionLineEdit->setText(connectionName);
}

QString RegisterDialog::serverType()
{
    QString typeName = ui->TypeComboBox->currentText();
    if (typeName == "PostgreSQL")
    {
        return "QPSQL";
    }
    else if (typeName == "MySQL")
    {
        return "QMYSQL";
    }
    else if (typeName == "SQLite")
    {
        return "QSQLITE";
    }
    return "";
}

void RegisterDialog::setServerType(const QString serverType)
{
    int typeIndex = 0;
    if (serverType == "QPSQL")
    {
        typeIndex = ui->TypeComboBox->findText("PostgreSQL");
    }
    else if (serverType == "QMYSQL")
    {
        typeIndex = ui->TypeComboBox->findText("MySQL");
    }
    else if (serverType == "QSQLITE")
    {
        typeIndex = ui->TypeComboBox->findText("SQLite");
    }
    ui->TypeComboBox->setCurrentIndex(typeIndex);
}

QString RegisterDialog::serverName()
{
    return ui->ServerLineEdit->text();
}

void RegisterDialog::setServerName(const QString serverName)
{
    ui->ServerLineEdit->setText(serverName);
}

int RegisterDialog::serverPort()
{
    QString port = ui->PortLineEdit->text();
    return port.toInt();
}

void RegisterDialog::setServerPort(const int port)
{
    ui->PortLineEdit->setText(QString::number(port));
}

QString RegisterDialog::database()
{
    return ui->DatabaseLineEdit->text();
}

void RegisterDialog::setDatabase(const QString database)
{
    ui->DatabaseLineEdit->setText(database);
}

QString RegisterDialog::username()
{
    return ui->UsernameLineEdit->text();
}

void RegisterDialog::setUsername(const QString username)
{
    ui->UsernameLineEdit->setText(username);
}

QString RegisterDialog::password()
{
    return ui->PasswordLineEdit->text();
}

void RegisterDialog::setPassword(const QString password)
{
    ui->PasswordLineEdit->setText(password);
}

void RegisterDialog::on_TypeComboBox_currentIndexChanged(int index)
{
    QString portNumber = ui->PortLineEdit->text();
    if (index == 0 && (portNumber.isEmpty() || portNumber == "3306" || portNumber == "0"))
    {
        ui->PortLineEdit->setText("5432");
    }
    else if (index == 1 && (portNumber.isEmpty() || portNumber == "5432" || portNumber == "0"))
    {
        ui->PortLineEdit->setText("3306");
    }
    else if (index == 2 && (portNumber.isEmpty() || portNumber == "5432" || portNumber == "3306"))
    {
        ui->PortLineEdit->setText("0");
    }
}
